This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 972860 - (abakus) Review Request: abakus - The simple KDE calculator
Review Request: abakus - The simple KDE calculator
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dridi Boukelmoune
Fedora Extras Quality Assurance
:
Depends On:
Blocks: kde-reviews
  Show dependency treegraph
 
Reported: 2013-06-10 12:29 EDT by Christopher Meng
Modified: 2013-09-03 18:23 EDT (History)
4 users (show)

See Also:
Fixed In Version: abakus-0.92-2.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-03 18:23:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dridi.boukelmoune: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-06-10 12:29:28 EDT
Spec URL: http://cicku.me/abakus.spec
SRPM URL: http://cicku.me/abakus-0.92-1.fc20.src.rpm
Description: Abakus is a simple calculator for KDE, based on a concept of Roberto 
Alsina's. Think of it as bc (the command-line calculator) with a nice GUI.
Fedora Account System Username: cicku
Comment 1 Dridi Boukelmoune 2013-07-30 07:35:47 EDT
Hi,

During my review I've found issues that look like blockers.

> MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.[1]

$ rpmlint SRPMS/abakus-0.92-1.fc20.src.rpm RPMS/x86_64/abakus-0.92-1.fc19.x86_64.rpm
abakus.src: W: spelling-error %description -l en_US bc -> BC, bx, b
abakus.x86_64: W: spelling-error %description -l en_US bc -> BC, bx, b
abakus.x86_64: E: incorrect-fsf-address /usr/share/doc/abakus-0.92/COPYING
abakus.x86_64: W: no-manual-page-for-binary abakus
2 packages and 0 specfiles checked; 1 errors, 3 warnings.

The missing man page should not be an issue for a GUI app. For the FSF address, it's in all source file headers, but only the COPYING file should be an issue. For the makeself package, I've solved this by adding the license as a second upstream source to override the outdated file. Abakus not being maintained, it's probably useless to ask the upstream to fix this.

Makeself review request: https://bugzilla.redhat.com/show_bug.cgi?id=989015
Spec sample:
Source1: https://www.gnu.org/licenses/gpl-2.0.txt

I suppose this is not ok until the licensing issue is solved.

> MUST: The package must be named according to the Package Naming Guidelines .
OK

> MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
OK

> MUST: The package must meet the Packaging Guidelines .
OK

> MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK

> MUST: The License field in the package spec file must match the actual license. [3]
Not OK, more like GPLv2+ according to source files headers.

> MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
OK

> MUST: The spec file must be written in American English. [5]
OK

> MUST: The spec file for the package MUST be legible. [6]
OK

> MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
OK

> MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
OK (x86_64)

There are warnings though.

> MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

I cannot test other architectures (maybe i686).

> MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
OK

> MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
n/a

> MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
n/a

> MUST: Packages must NOT bundle copies of system libraries.[11]
OK

> MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
n/a

> MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
OK

> MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
OK

> MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. [15]
OK

> MUST: Each package must consistently use macros. [16]
OK

> MUST: The package must contain code, or permissable content. [17]
OK

> MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
n/a

> MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
OK

> MUST: Static libraries must be in a -static package. [19]
n/a

> MUST: Development files must be in a -devel package. [20]
n/a

> MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]
n/a

> MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[19]
n/a

> MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
Not OK: not used in the spec, not found in the cmake install. Or maybe I'm missing some cmake convention ?

> MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
OK

> MUST: All filenames in rpm packages must be valid UTF-8. [24]
OK

> SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]
n/a

> SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]
n/a

> SHOULD: The reviewer should test that the package builds in mock. [27]
mock -r fedora-18-x86_64 abakus-0.92-1.fc20.src.rpm: Not OK (fedora-1[89]-x86_64

The mock builds consistently fail:
    RPM build errors:
        File must begin with "/": %{_iconsdir}/hicolor/*x*/apps/*.png

Inside the mock roots I get this:
    rpmbuild --showrc | grep icon
    -14: _kde4_iconsdir     %_kde4_sharedir/icons

> SHOULD: The package should compile and build into binary rpms on all supported architectures. [28]
Cannot tested

> SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
OK

Works fine on my x86_64 laptop with XFCE.

Messages in stderr:
abakus(2575)/kdeui (KIconLoader): Error: standard icon theme "oxygen" not found! 
abakus(2575)/kdeui (kdelibs): Shortcut for KAction  "select_edit" "Select Editor" set with QShortcut::setShortcut()! See KAction documentation.

> SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]
n/a

> SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]
n/a

> SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [30]
n/a

> SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]
n/a

> SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]
No man page, should not be a problem for a GUI app.

Dridi
Comment 2 Dridi Boukelmoune 2013-07-30 15:14:01 EDT
To build successfully with mock:
BuildRequires: jpackage-utils
Comment 3 Christopher Meng 2013-07-31 00:53:33 EDT
1. Well, not all times I can replace the COPYING, especially I cannot get permission of upstream.

But such error is not blocker.

Changed to GPLv2+.

2. I will suggest RPM adding iconsdir macro into main package, so now I will revert to datadir/icons. Add BR of jpackage is not good ;0

3. desktop-file-install is not a MUST, if package installs its desktop file by scripts but not by packager, we can validate it.

That's why I add %check section to make sure the desktop file matches the standard.

Spec URL: http://cicku.me/abakus.spec
SRPM URL: http://cicku.me/abakus-0.92-2.fc20.src.rpm
Comment 4 Dridi Boukelmoune 2013-07-31 14:29:21 EDT
(In reply to Christopher Meng from comment #3)
> 1. Well, not all times I can replace the COPYING, especially I cannot get
> permission of upstream.
> 
> But such error is not blocker.
> 
> Changed to GPLv2+.

I thought rpmlint errors were blockers, in this case it's ok.
License tag, OK!

> 2. I will suggest RPM adding iconsdir macro into main package, so now I will
> revert to datadir/icons. Add BR of jpackage is not good ;0

Yup I was also surprised when I found the macro came from this package.

> 3. desktop-file-install is not a MUST, if package installs its desktop file
> by scripts but not by packager, we can validate it.
> 
> That's why I add %check section to make sure the desktop file matches the
> standard.

Maybe the rule should be amended with something like "unless the upstream project provides it". Thanks for the explanation.

> Spec URL: http://cicku.me/abakus.spec
> SRPM URL: http://cicku.me/abakus-0.92-2.fc20.src.rpm

The package looks good to me, what's next ?
Comment 5 Christopher Meng 2013-07-31 23:56:43 EDT
If you are a packager, just approve it.

From your fasname dridi and varnish mod review, I think that you are not sponsored yet. 

I think you need to find a sponsor for your packages, and then let the sponsor sponsor you and then you have permissions to approve my packages.(Change flags "fedora-review" from blank to "+") But seems Ingvar is busy. :(

If you want to become a packager, the sponsor will ask you to review 1 or 2 other packages as this can prove if you really "understand" packaging. You can tell the sponsor about this one ;)
Comment 6 Kevin Kofler 2013-08-01 17:47:13 EDT
Replacing COPYING is usually a bad idea, we're not supposed to mess with upstream COPYING files in any way. (In fact, we aren't even supposed to add them if upstream forgot them entirely.)
Comment 7 Kevin Kofler 2013-08-02 05:57:59 EDT
Oh, and for desktop-file-install, the rule is that you must run EITHER desktop-file-install OR desktop-file-validate on each *.desktop file, both do the same validations (and there's an unwritten rule that files under desktop-environment-specific paths such as /usr/share/kde4/services need not be validated because they need to be valid only for the specific desktop environment, in this case for kdelibs).
Comment 8 Dridi Boukelmoune 2013-08-23 10:41:10 EDT
@Kevin, thanks for the explanations. As I said to Christopher, maybe this should be clarified in the wiki for desktop noobs like me.

@Christopher, looks like I'm allowed to change the flag since kevin's sponsored me :)
Comment 9 Mario Blättermann 2013-08-24 06:25:07 EDT
@Dridi, when approving a package, please assign the bug to you and set the state to "ASSIGNED".

Just a post-review comment: qt4-devel is pulled in by kdelibs-devel and can be dropped from the build requirements.
Comment 10 Christopher Meng 2013-08-24 06:34:05 EDT
(In reply to Mario Blättermann from comment #9)
> @Dridi, when approving a package, please assign the bug to you and set the
> state to "ASSIGNED".
> 
> Just a post-review comment: qt4-devel is pulled in by kdelibs-devel and can
> be dropped from the build requirements.

I don't want to drop it.
Comment 11 Christopher Meng 2013-08-24 06:39:39 EDT
New Package SCM Request
=======================
Package Name: abakus
Short Description: The simple KDE calculator
Owners: cicku
Branches: f19 f20
InitialCC:
Comment 12 Mario Blättermann 2013-08-24 06:40:17 EDT
(In reply to Christopher Meng from comment #10)
> I don't want to drop it.

OK, it's your choice.
Comment 13 Kevin Fenzi 2013-08-24 11:50:18 EDT
Git done (by process-git-requests).
Comment 14 Kevin Kofler 2013-08-25 17:24:58 EDT
And please BuildRequire kdelibs4-devel rather than kdelibs-devel, to be sure you always get kdelibs 4 and not kdelibs 3, KDE Frameworks 5 or whatever. An additional advantage of kdelibs4-devel is that that Provides has no Epoch, so BuildRequires: kdelibs4-devel >= 4.x.y works as expected.
Comment 15 Fedora Update System 2013-08-25 21:04:56 EDT
abakus-0.92-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/abakus-0.92-2.fc19
Comment 16 Dridi Boukelmoune 2013-08-26 06:13:41 EDT
@Mario, sorry about that, when I started the review I didn't have rights to put the fedora-review? flag (and I didn't try to assign it to myself).
Comment 17 Mario Blättermann 2013-08-26 06:18:27 EDT
(In reply to Dridi Boukelmoune from comment #16)
> @Mario, sorry about that, when I started the review I didn't have rights to
> put the fedora-review? flag (and I didn't try to assign it to myself).

Maybe, but once you have the ability to set the fedora-review flags, you can also assign a bug to you and set it ASSIGNED. Keep an eye on that for future reviews.
Comment 18 Fedora Update System 2013-08-26 18:28:59 EDT
abakus-0.92-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 19 Fedora Update System 2013-09-03 18:23:21 EDT
abakus-0.92-2.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.